// Objective-C API for talking to github.com/nknorg/ncp-go Go package.
//   gobind -lang=objc github.com/nknorg/ncp-go
//
// File is generated by gobind. Do not edit.

#ifndef __Ncp_H__
#define __Ncp_H__

@import Foundation;
#include "ref.h"
#include "Universe.objc.h"


@class NcpConfig;
@class NcpConnection;
@class NcpGenericError;
@class NcpSession;

@interface NcpConfig : NSObject <goSeqRefInterface> {
}
@property(strong, readonly) _Nonnull id _ref;

- (nonnull instancetype)initWithRef:(_Nonnull id)ref;
- (nonnull instancetype)init;
@property (nonatomic) BOOL nonStream;
@property (nonatomic) int32_t sessionWindowSize;
@property (nonatomic) int32_t mtu;
@property (nonatomic) int32_t initialConnectionWindowSize;
@property (nonatomic) int32_t maxConnectionWindowSize;
@property (nonatomic) int32_t minConnectionWindowSize;
@property (nonatomic) int32_t maxAckSeqListSize;
@property (nonatomic) int32_t flushInterval;
@property (nonatomic) int32_t linger;
@property (nonatomic) int32_t initialRetransmissionTimeout;
@property (nonatomic) int32_t maxRetransmissionTimeout;
@property (nonatomic) int32_t sendAckInterval;
@property (nonatomic) int32_t checkTimeoutInterval;
@property (nonatomic) int32_t checkBytesReadInterval;
@property (nonatomic) int32_t sendBytesReadThreshold;
@end

@interface NcpConnection : NSObject <goSeqRefInterface> {
}
@property(strong, readonly) _Nonnull id _ref;

- (nonnull instancetype)initWithRef:(_Nonnull id)ref;
- (nullable instancetype)init:(NcpSession* _Nullable)session localClientID:(NSString* _Nullable)localClientID remoteClientID:(NSString* _Nullable)remoteClientID;
// skipped field Connection.RWMutex with unsupported type: sync.RWMutex

- (void)lock;
- (void)rLock;
// skipped method Connection.RLocker with unsupported parameter or return types

- (void)rUnlock;
// skipped method Connection.ReceiveAck with unsupported parameter or return types

// skipped method Connection.RetransmissionTimeout with unsupported parameter or return types

// skipped method Connection.SendAck with unsupported parameter or return types

- (long)sendAckQueueLen;
// skipped method Connection.SendWindowUsed with unsupported parameter or return types

- (void)start;
- (void)unlock;
@end

@interface NcpGenericError : NSObject <goSeqRefInterface> {
}
@property(strong, readonly) _Nonnull id _ref;

- (nonnull instancetype)initWithRef:(_Nonnull id)ref;
- (nullable instancetype)init:(NSString* _Nullable)err timeout:(BOOL)timeout temporary:(BOOL)temporary;
- (NSString* _Nonnull)error;
- (BOOL)temporary;
- (BOOL)timeout;
@end

@interface NcpSession : NSObject <goSeqRefInterface> {
}
@property(strong, readonly) _Nonnull id _ref;

- (nonnull instancetype)initWithRef:(_Nonnull id)ref;
// skipped constructor Session.NewSession with unsupported parameter or return types

// skipped field Session.RWMutex with unsupported type: sync.RWMutex

- (BOOL)accept:(NSError* _Nullable* _Nullable)error;
- (BOOL)close:(NSError* _Nullable* _Nullable)error;
// skipped method Session.Dial with unsupported parameter or return types

// skipped method Session.GetBytesRead with unsupported parameter or return types

// skipped method Session.GetConnWindowSize with unsupported parameter or return types

// skipped method Session.GetDataToSend with unsupported parameter or return types

- (BOOL)isClosed;
- (BOOL)isEstablished;
- (BOOL)isStream;
// skipped method Session.LocalAddr with unsupported parameter or return types

- (void)lock;
- (void)rLock;
// skipped method Session.RLocker with unsupported parameter or return types

- (void)rUnlock;
- (BOOL)read:(NSData* _Nullable)b _:(long* _Nullable)_ error:(NSError* _Nullable* _Nullable)error;
- (BOOL)receiveWith:(NSString* _Nullable)localClientID remoteClientID:(NSString* _Nullable)remoteClientID buf:(NSData* _Nullable)buf error:(NSError* _Nullable* _Nullable)error;
// skipped method Session.RecvWindowUsed with unsupported parameter or return types

// skipped method Session.RemoteAddr with unsupported parameter or return types

// skipped method Session.SendWindowUsed with unsupported parameter or return types

// skipped method Session.SetDeadline with unsupported parameter or return types

/**
 * SetLinger sets session linger in unit of millisecond
 */
- (void)setLinger:(int32_t)t;
// skipped method Session.SetReadDeadline with unsupported parameter or return types

// skipped method Session.SetWriteDeadline with unsupported parameter or return types

- (void)unlock;
- (BOOL)write:(NSData* _Nullable)b _:(long* _Nullable)_ error:(NSError* _Nullable* _Nullable)error;
@end

FOUNDATION_EXPORT const int64_t NcpMinSequenceID;

@interface Ncp : NSObject
// skipped variable DefaultConfig with unsupported type: github.com/nknorg/ncp-go.Config

+ (NcpGenericError* _Nullable) errBufferSizeTooSmall;
+ (void) setErrBufferSizeTooSmall:(NcpGenericError* _Nullable)v;

+ (NcpGenericError* _Nullable) errConnClosed;
+ (void) setErrConnClosed:(NcpGenericError* _Nullable)v;

+ (NcpGenericError* _Nullable) errDataSizeTooLarge;
+ (void) setErrDataSizeTooLarge:(NcpGenericError* _Nullable)v;

+ (NcpGenericError* _Nullable) errInvalidPacket;
+ (void) setErrInvalidPacket:(NcpGenericError* _Nullable)v;

+ (NcpGenericError* _Nullable) errNotHandshake;
+ (void) setErrNotHandshake:(NcpGenericError* _Nullable)v;

+ (NcpGenericError* _Nullable) errReadDeadlineExceeded;
+ (void) setErrReadDeadlineExceeded:(NcpGenericError* _Nullable)v;

+ (NcpGenericError* _Nullable) errRecvWindowFull;
+ (void) setErrRecvWindowFull:(NcpGenericError* _Nullable)v;

+ (NcpGenericError* _Nullable) errSessionClosed;
+ (void) setErrSessionClosed:(NcpGenericError* _Nullable)v;

+ (NcpGenericError* _Nullable) errSessionEstablished;
+ (void) setErrSessionEstablished:(NcpGenericError* _Nullable)v;

+ (NcpGenericError* _Nullable) errSessionNotEstablished;
+ (void) setErrSessionNotEstablished:(NcpGenericError* _Nullable)v;

+ (NcpGenericError* _Nullable) errWriteDeadlineExceeded;
+ (void) setErrWriteDeadlineExceeded:(NcpGenericError* _Nullable)v;

@end

// skipped function CompareSeq with unsupported parameter or return types


FOUNDATION_EXPORT NcpConfig* _Nullable NcpMergeConfig(NcpConfig* _Nullable conf, NSError* _Nullable* _Nullable error);

FOUNDATION_EXPORT NcpConnection* _Nullable NcpNewConnection(NcpSession* _Nullable session, NSString* _Nullable localClientID, NSString* _Nullable remoteClientID, NSError* _Nullable* _Nullable error);

FOUNDATION_EXPORT NcpGenericError* _Nullable NcpNewGenericError(NSString* _Nullable err, BOOL timeout, BOOL temporary);

// skipped function NewSession with unsupported parameter or return types


// skipped function NextSeq with unsupported parameter or return types


// skipped function SeqInBetween with unsupported parameter or return types


#endif
